<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeviceNoteImage ArrayType
 * @subpackage Arrays
 */
class ArrayOfDeviceNoteImage extends AbstractStructArrayBase
{
    /**
     * The DeviceNoteImage
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\DeviceNoteImage[]
     */
    public $DeviceNoteImage;
    /**
     * Constructor method for ArrayOfDeviceNoteImage
     * @uses ArrayOfDeviceNoteImage::setDeviceNoteImage()
     * @param \CustomerManagement\StructType\DeviceNoteImage[] $deviceNoteImage
     */
    public function __construct(array $deviceNoteImage = array())
    {
        $this
            ->setDeviceNoteImage($deviceNoteImage);
    }
    /**
     * Get DeviceNoteImage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\DeviceNoteImage[]|null
     */
    public function getDeviceNoteImage()
    {
        return isset($this->DeviceNoteImage) ? $this->DeviceNoteImage : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeviceNoteImage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeviceNoteImage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeviceNoteImageForArrayConstraintsFromSetDeviceNoteImage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeviceNoteImageDeviceNoteImageItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeviceNoteImageDeviceNoteImageItem instanceof \CustomerManagement\StructType\DeviceNoteImage) {
                $invalidValues[] = is_object($arrayOfDeviceNoteImageDeviceNoteImageItem) ? get_class($arrayOfDeviceNoteImageDeviceNoteImageItem) : sprintf('%s(%s)', gettype($arrayOfDeviceNoteImageDeviceNoteImageItem), var_export($arrayOfDeviceNoteImageDeviceNoteImageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeviceNoteImage property can only contain items of type \CustomerManagement\StructType\DeviceNoteImage, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeviceNoteImage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\DeviceNoteImage[] $deviceNoteImage
     * @return \CustomerManagement\ArrayType\ArrayOfDeviceNoteImage
     */
    public function setDeviceNoteImage(array $deviceNoteImage = array())
    {
        // validation for constraint: array
        if ('' !== ($deviceNoteImageArrayErrorMessage = self::validateDeviceNoteImageForArrayConstraintsFromSetDeviceNoteImage($deviceNoteImage))) {
            throw new \InvalidArgumentException($deviceNoteImageArrayErrorMessage, __LINE__);
        }
        if (is_null($deviceNoteImage) || (is_array($deviceNoteImage) && empty($deviceNoteImage))) {
            unset($this->DeviceNoteImage);
        } else {
            $this->DeviceNoteImage = $deviceNoteImage;
        }
        return $this;
    }
    /**
     * Add item to DeviceNoteImage value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\DeviceNoteImage $item
     * @return \CustomerManagement\ArrayType\ArrayOfDeviceNoteImage
     */
    public function addToDeviceNoteImage(\CustomerManagement\StructType\DeviceNoteImage $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\DeviceNoteImage) {
            throw new \InvalidArgumentException(sprintf('The DeviceNoteImage property can only contain items of type \CustomerManagement\StructType\DeviceNoteImage, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeviceNoteImage[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\DeviceNoteImage|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\DeviceNoteImage|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\DeviceNoteImage|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\DeviceNoteImage|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\DeviceNoteImage|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeviceNoteImage
     */
    public function getAttributeName()
    {
        return 'DeviceNoteImage';
    }
}
